#!/bin/sh
#############################################################################
#
# Licensed Materials - Property of IBM
#
# (C) COPYRIGHT International Business Machines Corp. 2007, 2008
#
# All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#############################################################################


if [ $# -ne 2 ] ; then
        echo "Usage: $0 <instance_user> <database_name>"
        exit 1
fi

checkError() {
        ERROR=$?
        if [ $ERROR -ne 0 ] ; then
                echo " Error $ERROR"
                exit 1
        else
                echo " OK"
        fi
}

INSTANCE_USER=$1
DB_NAME=$2
CONNXML=/usr/share/YaST2/include/db2config/connStore.xml.db2exp
CONNSTORE=/srv/www/htdocs/TE/connectionStore

if [ -d ${CONNSTORE} ] ; then
	cp ${CONNXML} ${CONNSTORE}/connStore.xml > /dev/null 2>&1
fi

perl -pi -e s/%INSTANCEUSER%/${INSTANCE_USER}/g ${CONNSTORE}/connStore.xml > /dev/null 2>&1
perl -pi -e s/%DBNAME%/${DB_NAME}/ ${CONNSTORE}/connStore.xml > /dev/null 2>&1

rcapache2 restart > /dev/null 2>&1

exit 0
