#!/bin/bash
set -xv

PARTITIONS=`ls  /db2fs/tablespaces/ 2>/dev/null | wc -l`;

checkError() {
	ERROR=$?
	if [ $ERROR -ne 0 ] ; then
		echo " Error $ERROR"
		exit 1
	else
		echo " OK"
	fi
} 




restartDatabase() {
 echo -n "Stop Database"
 db2stop > /dev/null 2>&1
 checkError
 echo -n "Start Database"
 db2start > /dev/null 2>&1
 checkError
}









if [ $PARTITIONS -ne 0 ] ; then

	if [ $PARTITIONS -gt 1 ] ; then
		db2stop force >/dev/null 2>&1
		rm $HOME/sqllib/db2nodes.cfg
		COUNTER=0
		HOSTNAME=`hostname -s`;
		while [ $COUNTER -lt $PARTITIONS ] ; do 
			echo "$COUNTER $HOSTNAME $COUNTER $HOSTNAME" >> $HOME/sqllib/db2nodes.cfg
			COUNTER=$(($COUNTER+1))
		done
		echo -n "Start DB2"
		db2start >/dev/null 2>&1 
                checkError
			
	fi
fi
exit 0
	



