#!/usr/bin/perl

#############################################################################
# Licensed Materials - Property of IBM
#
# IBM CONFIDENTIAL
# OCO SOURCE MATERIALS
#
# (C) COPYRIGHT International Business Machines Corp. 2007, 2008
#
# All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# The source code for this program is not published or otherwise divested of
# its trade secrets, irrespective of what has been deposited with the U.S.
# Copyright Office.
############################################################################


$SEARCH = "versionInfo.sh";
@SEARCHPATH = ("/opt/ibm/", "/opt", "/");
$VERSIONINFO = "";

#
# /etc/sysconfig/was
#
$SYSCONFIGFILE = "/etc/sysconfig/db2ec";
#
# variables for sys
#
#


#
# try to find versionInfo and call it.
# Returns the output of all versionInfo found
#
sub find () {

	@ret = ();
	foreach $i (@SEARCHPATH) {
		 @found = `find $i -name $SEARCH`;
		 foreach $i (@found) {
			 chomp $i;
			 @result = `$i`;
			 push @ret, \@result;
		 }
		 if (@ret > 0 ) {
			 return \@ret;
		 }
	 }
	return \@ret;
}






						 


sub valBetweenQuotes($) {
	$val = shift;
	if ( $val =~ /^\"(.*)\"$/ ) {
		$r = $1;
		return $r;
	}
	return $val;
}


sub trimVal($) {
	$val = shift;
	$val =  valBetweenQuotes($val);
	if ( $val =~ /^\s+/ ) {
		$r = $';
		return trimVal($r);
	}
	elsif ( $val =~ /\s+$/ ) {
		$r = $`;
		return $r;
	}
	return $val;
}


sub readSysConfigFile() {
	open(FH,"<$SYSCONFIGFILE") || return undef;
	
	my @lines = <FH>;
	close(FH);
	return \@lines;
}

sub writeSysConfigFile($) {
	my $vals = shift;
	if (! -e $SYSCONFIGFILE) {
		print "Error\n";
		return 1;
	}
	if (! rename( $SYSCONFIGFILE,  $SYSCONFIGFILE . ".backup") ) {
		return undef;
	}
	if (! open(FH,">$SYSCONFIGFILE") ) {
		print "Error2\n";
		rename( $SYSCONFIGFILE . ".backup",  $SYSCONFIGFILE);
		return 2;
	}
	foreach $i (@{$vals}) {
		print FH $i;
	}
	if (!close(FH) ) {
		unlink( $SYSCONFIGFILE );
		rename( $SYSCONFIGFILE . ".backup",  $SYSCONFIGFILE);
		return 3;
	}
	else {
		unlink( $SYSCONFIGFILE  . ".backup" );
	}
	return 0;
}
	

sub setValue($$$) {
	my($a,$var,$val) = @_;
	my @ret = ();
	foreach $i (@{$a}) {
		if ($i =~ /^#/ ) {
			push (@ret, $i);
		}
		else {
			@b = split(/=/, $i, 2);
			if (@b == 2) {
				$var1 = trimVal($b[0]);
				$val1 = trimVal($b[1]);
				if ($var1 eq $var ) {
					my $j = $var . "=\"" . $val . "\"\n";
					push( @ret, $j);
				}
				else {
					push (@ret, $i);
				}
			}
			else {
				push (@ret, $i);
			}
		}
	}
	return \@ret;
}

sub setValues($$) {
	my($a, $args) =  @_;
	my $ret = $a;
	foreach $i (@{$args} ) {
		@b = split(/=/, $i, 2);
		if (@b == 2) {
			$var = trimVal($b[0]);
			$val = trimVal($b[1]);
			$ret = setValue($ret, $var, $val);
		}
	}
	return $ret;
}
	


$v = readSysConfigFile();
$v1 = setValues($v,\@ARGV);
exit (writeSysConfigFile($v1));




	



